package com.fr.plugin.sxka.sso;

import com.fr.decision.fun.impl.AbstractLogInOutEventProvider;
import com.fr.decision.webservice.login.LogInOutResultInfo;
import com.fr.decision.webservice.utils.DecisionStatusService;
import com.fr.general.PropertiesUtils;
import com.fr.log.FineLoggerFactory;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;

/**
 * @Author fr.open
 * @Date 2020/9/18
 * @Description
 **/
public class CustomLogInOutEventProvider extends AbstractLogInOutEventProvider {
    @Override
    public String logoutAction(LogInOutResultInfo result) {
        String state = getUserStateFromCookie(result.getRequest());
        try {
            DecisionStatusService.loginStatusService().delete(state);
        } catch (Exception e) {
            FineLoggerFactory.getLogger().error(e.getMessage(),e);
        }
        String logout = PropertiesUtils.getProperties("conf").getProperty("logout");
        String format = "%s?client_id=%s&callback=%s&state=%s";
        return String.format(format, logout, PropertiesUtils.getProperties("conf").getProperty("client_id"), PropertiesUtils.getProperties("conf").getProperty("redirect_uri"),state);
    }

    private String getUserStateFromCookie(HttpServletRequest request) {
        if (request.getCookies() == null) return null;

        for (Cookie cookie : request.getCookies()) {
            if ("uid_state".equals(cookie.getName())) return cookie.getValue();
        }
        return null;
    }

}
